# CustomerApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createCustomerAutomatic**](CustomerApi.md#createCustomerAutomatic) | **POST** /createCustomerAutomatic | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
[**createCustomerAutomaticWithDelayReviewRequest**](CustomerApi.md#createCustomerAutomaticWithDelayReviewRequest) | **POST** /createCustomerAutomaticWithDelayReviewRequest | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
[**createCustomerImmediateFirstReviewRequest**](CustomerApi.md#createCustomerImmediateFirstReviewRequest) | **POST** /createCustomerImmediateFirstReviewRequest | Create a Customer AND Feedback / Review Requests
[**createCustomerManualScheduleOneReviewRequest**](CustomerApi.md#createCustomerManualScheduleOneReviewRequest) | **POST** /createCustomerManualScheduleOneReviewRequest | Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
[**deleteCustomer**](CustomerApi.md#deleteCustomer) | **DELETE** /deleteCustomer | Delete ONE Customer record
[**getAllCustomersBycompanyId**](CustomerApi.md#getAllCustomersBycompanyId) | **GET** /getAllCustomersBycompanyId | Get Information on ALL Customers of a Company / Location / Feedback Page
[**getCustomersWhoHaveNotYetSubmittedReview**](CustomerApi.md#getCustomersWhoHaveNotYetSubmittedReview) | **GET** /getCustomersWhoHaveNotYetSubmittedReview | Get a list of Customers who have not yet submitted their Review / Feedback
[**getSingleCustomer**](CustomerApi.md#getSingleCustomer) | **GET** /getSingleCustomer | Get Information of ONE Customer
[**updateCustomer**](CustomerApi.md#updateCustomer) | **PUT** /updateCustomer | Update the record of ONE Customer


<a name="createCustomerAutomatic"></a>
# **createCustomerAutomatic**
> String createCustomerAutomatic(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes)

Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)

This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
String firstname = "firstname_example"; // String | Customer First Name
String lastname = "lastname_example"; // String | Customer Last Name
String sendtype = "1"; // String | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\" 
String email = "email_example"; // String | Customer Email
String mobile = "mobile_example"; // String | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
String address = "address_example"; // String | Customer Postal Address
String zipcode = "zipcode_example"; // String | Customer Zipcode
String city = "city_example"; // String | Customer City
String state = "state_example"; // String | Customer State / Province / Region
String country = "country_example"; // String | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
String notes = "notes_example"; // String | Additional Customer Notes
try {
    String result = apiInstance.createCustomerAutomatic(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#createCustomerAutomatic");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **firstname** | **String**| Customer First Name |
 **lastname** | **String**| Customer Last Name |
 **sendtype** | **String**| Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  | [default to 1] [enum: 1, 2, 1,2]
 **email** | **String**| Customer Email | [optional]
 **mobile** | **String**| Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  | [optional]
 **address** | **String**| Customer Postal Address | [optional]
 **zipcode** | **String**| Customer Zipcode | [optional]
 **city** | **String**| Customer City | [optional]
 **state** | **String**| Customer State / Province / Region | [optional]
 **country** | **String**| Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  | [optional]
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | [optional]
 **notes** | **String**| Additional Customer Notes | [optional]

### Return type

**String**

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="createCustomerAutomaticWithDelayReviewRequest"></a>
# **createCustomerAutomaticWithDelayReviewRequest**
> createCustomerAutomaticWithDelayReviewRequest(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes)

Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)

This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
String firstname = "firstname_example"; // String | Customer First Name
String lastname = "lastname_example"; // String | Customer Last Name
String sendtype = "1"; // String | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\" 
String delayBeforeFirstReviewRequest = "delayBeforeFirstReviewRequest_example"; // String | Delay before sending the first Feedback / Review Request (Allowed values: \"immediately\", \"X minute\", \"X hour\", \"X day\", \"X week\", \"X month\", \"X year\") 
String email = "email_example"; // String | Customer Email
String mobile = "mobile_example"; // String | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
String address = "address_example"; // String | Customer Postal Address
String zipcode = "zipcode_example"; // String | Customer Zipcode
String city = "city_example"; // String | Customer City
String state = "state_example"; // String | Customer State / Province / Region
String country = "country_example"; // String | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
String notes = "notes_example"; // String | Additional Customer Notes
try {
    apiInstance.createCustomerAutomaticWithDelayReviewRequest(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#createCustomerAutomaticWithDelayReviewRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **firstname** | **String**| Customer First Name |
 **lastname** | **String**| Customer Last Name |
 **sendtype** | **String**| Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  | [default to 1] [enum: 1, 2, 1,2]
 **delayBeforeFirstReviewRequest** | **String**| Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  |
 **email** | **String**| Customer Email | [optional]
 **mobile** | **String**| Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  | [optional]
 **address** | **String**| Customer Postal Address | [optional]
 **zipcode** | **String**| Customer Zipcode | [optional]
 **city** | **String**| Customer City | [optional]
 **state** | **String**| Customer State / Province / Region | [optional]
 **country** | **String**| Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  | [optional]
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | [optional]
 **notes** | **String**| Additional Customer Notes | [optional]

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="createCustomerImmediateFirstReviewRequest"></a>
# **createCustomerImmediateFirstReviewRequest**
> createCustomerImmediateFirstReviewRequest(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes)

Create a Customer AND Feedback / Review Requests

This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
String firstname = "firstname_example"; // String | Customer First Name
String lastname = "lastname_example"; // String | Customer Last Name
String sendtype = "1"; // String | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\" 
String email = "email_example"; // String | Customer Email
String mobile = "mobile_example"; // String | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
String address = "address_example"; // String | Customer Postal Address
String zipcode = "zipcode_example"; // String | Customer Zipcode
String city = "city_example"; // String | Customer City
String state = "state_example"; // String | Customer State / Province / Region
String country = "country_example"; // String | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
String notes = "notes_example"; // String | Additional Customer Notes
try {
    apiInstance.createCustomerImmediateFirstReviewRequest(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#createCustomerImmediateFirstReviewRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **firstname** | **String**| Customer First Name |
 **lastname** | **String**| Customer Last Name |
 **sendtype** | **String**| Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  | [default to 1] [enum: 1, 2, 1,2]
 **email** | **String**| Customer Email | [optional]
 **mobile** | **String**| Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  | [optional]
 **address** | **String**| Customer Postal Address | [optional]
 **zipcode** | **String**| Customer Zipcode | [optional]
 **city** | **String**| Customer City | [optional]
 **state** | **String**| Customer State / Province / Region | [optional]
 **country** | **String**| Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  | [optional]
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | [optional]
 **notes** | **String**| Additional Customer Notes | [optional]

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="createCustomerManualScheduleOneReviewRequest"></a>
# **createCustomerManualScheduleOneReviewRequest**
> createCustomerManualScheduleOneReviewRequest(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes)

Create a Customer AND a one Feedback / Review Request (Manual Scheduling)

This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
String firstname = "firstname_example"; // String | Customer First Name
String lastname = "lastname_example"; // String | Customer Last Name
String sendtype = "1"; // String | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\" 
String emailnumber = "1"; // String | Set which Email Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 
String smsnumber = "1"; // String | Set which SMS Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 
String scheduledate = "scheduledate_example"; // String | Schedule date (yyyy/mm/dd) 
String scheduletime = "scheduletime_example"; // String | Schedule time (HH:MM 24 hours format) 
String email = "email_example"; // String | Customer Email
String mobile = "mobile_example"; // String | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
String address = "address_example"; // String | Customer Postal Address
String zipcode = "zipcode_example"; // String | Customer Zipcode
String city = "city_example"; // String | Customer City
String state = "state_example"; // String | Customer State / Province / Region
String country = "country_example"; // String | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
String notes = "notes_example"; // String | Additional Customer Notes
try {
    apiInstance.createCustomerManualScheduleOneReviewRequest(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#createCustomerManualScheduleOneReviewRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **firstname** | **String**| Customer First Name |
 **lastname** | **String**| Customer Last Name |
 **sendtype** | **String**| Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  | [default to 1] [enum: 1, 2, 1,2]
 **emailnumber** | **String**| Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1] [enum: 1, 2, 3]
 **smsnumber** | **String**| Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1] [enum: 1, 2, 3]
 **scheduledate** | **String**| Schedule date (yyyy/mm/dd)  |
 **scheduletime** | **String**| Schedule time (HH:MM 24 hours format)  |
 **email** | **String**| Customer Email | [optional]
 **mobile** | **String**| Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  | [optional]
 **address** | **String**| Customer Postal Address | [optional]
 **zipcode** | **String**| Customer Zipcode | [optional]
 **city** | **String**| Customer City | [optional]
 **state** | **String**| Customer State / Province / Region | [optional]
 **country** | **String**| Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  | [optional]
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | [optional]
 **notes** | **String**| Additional Customer Notes | [optional]

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="deleteCustomer"></a>
# **deleteCustomer**
> deleteCustomer(customerid)

Delete ONE Customer record

This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String customerid = "customerid_example"; // String | Customer ID
try {
    apiInstance.deleteCustomer(customerid);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#deleteCustomer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getAllCustomersBycompanyId"></a>
# **getAllCustomersBycompanyId**
> List&lt;Customer&gt; getAllCustomersBycompanyId(companyid)

Get Information on ALL Customers of a Company / Location / Feedback Page

This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<Customer> result = apiInstance.getAllCustomersBycompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#getAllCustomersBycompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;Customer&gt;**](Customer.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getCustomersWhoHaveNotYetSubmittedReview"></a>
# **getCustomersWhoHaveNotYetSubmittedReview**
> List&lt;CustomerWhoHaveNotResponded&gt; getCustomersWhoHaveNotYetSubmittedReview(companyid)

Get a list of Customers who have not yet submitted their Review / Feedback

This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<CustomerWhoHaveNotResponded> result = apiInstance.getCustomersWhoHaveNotYetSubmittedReview(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#getCustomersWhoHaveNotYetSubmittedReview");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;CustomerWhoHaveNotResponded&gt;**](CustomerWhoHaveNotResponded.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getSingleCustomer"></a>
# **getSingleCustomer**
> List&lt;Customer&gt; getSingleCustomer(customerid)

Get Information of ONE Customer

This API call returns information from Reputation Builder on ONE existing Customer

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String customerid = "customerid_example"; // String | Customer ID
try {
    List<Customer> result = apiInstance.getSingleCustomer(customerid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#getSingleCustomer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |

### Return type

[**List&lt;Customer&gt;**](Customer.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="updateCustomer"></a>
# **updateCustomer**
> updateCustomer(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language)

Update the record of ONE Customer

This API call updates information from Reputation Builder on ONE existing Customer

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.CustomerApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

CustomerApi apiInstance = new CustomerApi();
String customerid = "customerid_example"; // String | Customer ID
String firstname = "firstname_example"; // String | Customer First Name
String lastname = "lastname_example"; // String | Customer Last Name
String notes = "notes_example"; // String | Additional Customer Notes
String email = "email_example"; // String | Customer Email
String mobile = "mobile_example"; // String | Customer Mobile Phone
String address = "address_example"; // String | Customer Postal Address
String zipcode = "zipcode_example"; // String | Customer Zipcode
String city = "city_example"; // String | Customer City
String state = "state_example"; // String | Customer State / Province / Region
String country = "country_example"; // String | Customer Country
String language = "language_example"; // String | Customer Language
try {
    apiInstance.updateCustomer(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language);
} catch (ApiException e) {
    System.err.println("Exception when calling CustomerApi#updateCustomer");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |
 **firstname** | **String**| Customer First Name |
 **lastname** | **String**| Customer Last Name |
 **notes** | **String**| Additional Customer Notes |
 **email** | **String**| Customer Email | [optional]
 **mobile** | **String**| Customer Mobile Phone | [optional]
 **address** | **String**| Customer Postal Address | [optional]
 **zipcode** | **String**| Customer Zipcode | [optional]
 **city** | **String**| Customer City | [optional]
 **state** | **String**| Customer State / Province / Region | [optional]
 **country** | **String**| Customer Country | [optional]
 **language** | **String**| Customer Language | [optional]

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

