# QueueApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteQueueByCustomerId**](QueueApi.md#deleteQueueByCustomerId) | **DELETE** /deleteQueueByCustomerId | Delete requests of a customer
[**deleteQueueBycompanyId**](QueueApi.md#deleteQueueBycompanyId) | **DELETE** /deleteQueueBycompanyId | Delete requests of a company
[**getQueueBycompanyId**](QueueApi.md#getQueueBycompanyId) | **GET** /getQueueBycompanyId | Get a customerâ€™s queue
[**getSingleCustomerQueue**](QueueApi.md#getSingleCustomerQueue) | **GET** /getQueueByCustomerId | Get a customerâ€™s queue


<a name="deleteQueueByCustomerId"></a>
# **deleteQueueByCustomerId**
> deleteQueueByCustomerId(customerid)

Delete requests of a customer

Delete requests of a customer

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueueApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

QueueApi apiInstance = new QueueApi();
String customerid = "customerid_example"; // String | Customer ID
try {
    apiInstance.deleteQueueByCustomerId(customerid);
} catch (ApiException e) {
    System.err.println("Exception when calling QueueApi#deleteQueueByCustomerId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="deleteQueueBycompanyId"></a>
# **deleteQueueBycompanyId**
> deleteQueueBycompanyId(companyid)

Delete requests of a company

Delete requests of a company

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueueApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

QueueApi apiInstance = new QueueApi();
String companyid = "companyid_example"; // String | Company ID
try {
    apiInstance.deleteQueueBycompanyId(companyid);
} catch (ApiException e) {
    System.err.println("Exception when calling QueueApi#deleteQueueBycompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getQueueBycompanyId"></a>
# **getQueueBycompanyId**
> List&lt;Queue&gt; getQueueBycompanyId(companyid)

Get a customerâ€™s queue

Get a customerâ€™s queue

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueueApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

QueueApi apiInstance = new QueueApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<Queue> result = apiInstance.getQueueBycompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueueApi#getQueueBycompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;Queue&gt;**](Queue.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getSingleCustomerQueue"></a>
# **getSingleCustomerQueue**
> List&lt;Queue&gt; getSingleCustomerQueue(customerid)

Get a customerâ€™s queue

Get a customerâ€™s queue

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueueApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

QueueApi apiInstance = new QueueApi();
String customerid = "customerid_example"; // String | Customer ID
try {
    List<Queue> result = apiInstance.getSingleCustomerQueue(customerid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueueApi#getSingleCustomerQueue");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |

### Return type

[**List&lt;Queue&gt;**](Queue.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

