# RescheduleApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**rescheduleCustomerAutomatic**](RescheduleApi.md#rescheduleCustomerAutomatic) | **POST** /rescheduleCustomerAutomatic | Reschedule Customer (Automatic)
[**rescheduleCustomerImmediate**](RescheduleApi.md#rescheduleCustomerImmediate) | **POST** /rescheduleCustomerImmediate | Reschedule Customer (Send right away)
[**rescheduleManualOneReviewRequest**](RescheduleApi.md#rescheduleManualOneReviewRequest) | **POST** /rescheduleManualOneReviewRequest | Reschedule Customer (Manual Schedule)


<a name="rescheduleCustomerAutomatic"></a>
# **rescheduleCustomerAutomatic**
> rescheduleCustomerAutomatic(customerid, language)

Reschedule Customer (Automatic)

Reschedule Customer (Automatic) 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.RescheduleApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

RescheduleApi apiInstance = new RescheduleApi();
String customerid = "customerid_example"; // String | Customer ID
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
try {
    apiInstance.rescheduleCustomerAutomatic(customerid, language);
} catch (ApiException e) {
    System.err.println("Exception when calling RescheduleApi#rescheduleCustomerAutomatic");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="rescheduleCustomerImmediate"></a>
# **rescheduleCustomerImmediate**
> rescheduleCustomerImmediate(customerid, language)

Reschedule Customer (Send right away)

Reschedule Customer (Send right away) 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.RescheduleApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

RescheduleApi apiInstance = new RescheduleApi();
String customerid = "customerid_example"; // String | Customer ID
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
try {
    apiInstance.rescheduleCustomerImmediate(customerid, language);
} catch (ApiException e) {
    System.err.println("Exception when calling RescheduleApi#rescheduleCustomerImmediate");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="rescheduleManualOneReviewRequest"></a>
# **rescheduleManualOneReviewRequest**
> rescheduleManualOneReviewRequest(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber)

Reschedule Customer (Manual Schedule)

Reschedule Customer (Manual Schedule) 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.RescheduleApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

RescheduleApi apiInstance = new RescheduleApi();
String customerid = "customerid_example"; // String | Customer ID
String language = "language_example"; // String | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
String scheduledate = "scheduledate_example"; // String | Schedule date (yyyy/mm/dd) 
String scheduletime = "scheduletime_example"; // String | Schedule time (HH:MM 24 hours format) 
String emailnumber = "1"; // String | Set which Email Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 
String smsnumber = "1"; // String | Set which SMS Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 
try {
    apiInstance.rescheduleManualOneReviewRequest(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber);
} catch (ApiException e) {
    System.err.println("Exception when calling RescheduleApi#rescheduleManualOneReviewRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **String**| Customer ID |
 **language** | **String**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  |
 **scheduledate** | **String**| Schedule date (yyyy/mm/dd)  |
 **scheduletime** | **String**| Schedule time (HH:MM 24 hours format)  |
 **emailnumber** | **String**| Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1] [enum: 1, 2, 3]
 **smsnumber** | **String**| Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1] [enum: 1, 2, 3]

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

