# ReviewSitesApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllReviewSitesByUserName**](ReviewSitesApi.md#getAllReviewSitesByUserName) | **GET** /getAllReviewSitesByUserName | Get all review sites of an account
[**getAllReviewSitesBycompanyId**](ReviewSitesApi.md#getAllReviewSitesBycompanyId) | **GET** /getAllReviewSitesBycompanyId | Get all review sites of a company


<a name="getAllReviewSitesByUserName"></a>
# **getAllReviewSitesByUserName**
> List&lt;ReviewSites&gt; getAllReviewSitesByUserName(username)

Get all review sites of an account

Get all review sites of an account

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewSitesApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewSitesApi apiInstance = new ReviewSitesApi();
String username = "username_example"; // String | User Name or Email address
try {
    List<ReviewSites> result = apiInstance.getAllReviewSitesByUserName(username);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewSitesApi#getAllReviewSitesByUserName");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**| User Name or Email address |

### Return type

[**List&lt;ReviewSites&gt;**](ReviewSites.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getAllReviewSitesBycompanyId"></a>
# **getAllReviewSitesBycompanyId**
> List&lt;ReviewSites&gt; getAllReviewSitesBycompanyId(companyid)

Get all review sites of a company

Get all review sites of a company

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewSitesApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewSitesApi apiInstance = new ReviewSitesApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<ReviewSites> result = apiInstance.getAllReviewSitesBycompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewSitesApi#getAllReviewSitesBycompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;ReviewSites&gt;**](ReviewSites.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

