# ReviewsStatsApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getNumberOfReviewsPostedInLastDaysByCompanyId**](ReviewsStatsApi.md#getNumberOfReviewsPostedInLastDaysByCompanyId) | **GET** /getNumberOfReviewsPostedInLastDaysByCompanyId | Get total reviews received for each review site
[**getNumberOfReviewsRequiredToAchieve5StarByCompanyId**](ReviewsStatsApi.md#getNumberOfReviewsRequiredToAchieve5StarByCompanyId) | **GET** /getNumberOfReviewsRequiredToAchieve5StarByCompanyId | Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
[**getOverallRatingAndReviewCountForPlatformReviewsByCompanyId**](ReviewsStatsApi.md#getOverallRatingAndReviewCountForPlatformReviewsByCompanyId) | **GET** /getOverallRatingAndReviewCountForPlatformReviewsByCompanyId | Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
[**getOverallRatingForEachReviewSiteByCompanyId**](ReviewsStatsApi.md#getOverallRatingForEachReviewSiteByCompanyId) | **GET** /getOverallRatingForEachReviewSiteByCompanyId | Get overall rating for each review site
[**getOverallRatingOfCompanyByCompanyId**](ReviewsStatsApi.md#getOverallRatingOfCompanyByCompanyId) | **GET** /getOverallRatingOfCompanyByCompanyId | Get The Overall Rating of a Company / Location / Feedback Page 
[**getOverallReputationChangeOfAllReviewSitesByCompanyId**](ReviewsStatsApi.md#getOverallReputationChangeOfAllReviewSitesByCompanyId) | **GET** /getOverallReputationChangeOfAllReviewSitesByCompanyId | Get the Overall Reputation Increase / Decrease of ALL Review Sites 
[**getTotalReviewsReceivedForEachReviewSiteByCompanyId**](ReviewsStatsApi.md#getTotalReviewsReceivedForEachReviewSiteByCompanyId) | **GET** /getTotalReviewsReceivedForEachReviewSiteByCompanyId | Get total reviews received for each review site


<a name="getNumberOfReviewsPostedInLastDaysByCompanyId"></a>
# **getNumberOfReviewsPostedInLastDaysByCompanyId**
> List&lt;ReviewSitesReviewCount&gt; getNumberOfReviewsPostedInLastDaysByCompanyId(companyid, lastHowManyDays)

Get total reviews received for each review site

Get total reviews received for each review site

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
String lastHowManyDays = "lastHowManyDays_example"; // String | Last how many days
try {
    List<ReviewSitesReviewCount> result = apiInstance.getNumberOfReviewsPostedInLastDaysByCompanyId(companyid, lastHowManyDays);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getNumberOfReviewsPostedInLastDaysByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **lastHowManyDays** | **String**| Last how many days |

### Return type

[**List&lt;ReviewSitesReviewCount&gt;**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getNumberOfReviewsRequiredToAchieve5StarByCompanyId"></a>
# **getNumberOfReviewsRequiredToAchieve5StarByCompanyId**
> List&lt;ReviewSitesReviewCount&gt; getNumberOfReviewsRequiredToAchieve5StarByCompanyId(companyid)

Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 

This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<ReviewSitesReviewCount> result = apiInstance.getNumberOfReviewsRequiredToAchieve5StarByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getNumberOfReviewsRequiredToAchieve5StarByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;ReviewSitesReviewCount&gt;**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getOverallRatingAndReviewCountForPlatformReviewsByCompanyId"></a>
# **getOverallRatingAndReviewCountForPlatformReviewsByCompanyId**
> List&lt;OverallRatingAndReviewCount&gt; getOverallRatingAndReviewCountForPlatformReviewsByCompanyId(companyid)

Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  

Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<OverallRatingAndReviewCount> result = apiInstance.getOverallRatingAndReviewCountForPlatformReviewsByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getOverallRatingAndReviewCountForPlatformReviewsByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;OverallRatingAndReviewCount&gt;**](OverallRatingAndReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getOverallRatingForEachReviewSiteByCompanyId"></a>
# **getOverallRatingForEachReviewSiteByCompanyId**
> List&lt;ReviewSitesRating&gt; getOverallRatingForEachReviewSiteByCompanyId(companyid)

Get overall rating for each review site

Get overall rating for each review site

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<ReviewSitesRating> result = apiInstance.getOverallRatingForEachReviewSiteByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getOverallRatingForEachReviewSiteByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;ReviewSitesRating&gt;**](ReviewSitesRating.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getOverallRatingOfCompanyByCompanyId"></a>
# **getOverallRatingOfCompanyByCompanyId**
> List&lt;OverallCompanyRating&gt; getOverallRatingOfCompanyByCompanyId(companyid)

Get The Overall Rating of a Company / Location / Feedback Page 

This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<OverallCompanyRating> result = apiInstance.getOverallRatingOfCompanyByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getOverallRatingOfCompanyByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;OverallCompanyRating&gt;**](OverallCompanyRating.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getOverallReputationChangeOfAllReviewSitesByCompanyId"></a>
# **getOverallReputationChangeOfAllReviewSitesByCompanyId**
> List&lt;ReviewSitesReputationChange&gt; getOverallReputationChangeOfAllReviewSitesByCompanyId(companyid)

Get the Overall Reputation Increase / Decrease of ALL Review Sites 

This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<ReviewSitesReputationChange> result = apiInstance.getOverallReputationChangeOfAllReviewSitesByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getOverallReputationChangeOfAllReviewSitesByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;ReviewSitesReputationChange&gt;**](ReviewSitesReputationChange.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getTotalReviewsReceivedForEachReviewSiteByCompanyId"></a>
# **getTotalReviewsReceivedForEachReviewSiteByCompanyId**
> List&lt;ReviewSitesReviewCount&gt; getTotalReviewsReceivedForEachReviewSiteByCompanyId(companyid)

Get total reviews received for each review site

Get total reviews received for each review site

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsStatsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsStatsApi apiInstance = new ReviewsStatsApi();
String companyid = "companyid_example"; // String | Company ID
try {
    List<ReviewSitesReviewCount> result = apiInstance.getTotalReviewsReceivedForEachReviewSiteByCompanyId(companyid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsStatsApi#getTotalReviewsReceivedForEachReviewSiteByCompanyId");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |

### Return type

[**List&lt;ReviewSitesReviewCount&gt;**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

