/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Customer;
import io.swagger.client.model.CustomerWhoHaveNotResponded;
import io.swagger.client.model.Error;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CustomerApi {
    private ApiClient apiClient;

    public CustomerApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CustomerApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createCustomerAutomatic
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createCustomerAutomaticCall(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/createCustomerAutomatic";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (companyid != null)
        localVarFormParams.put("companyid", companyid);
        if (firstname != null)
        localVarFormParams.put("firstname", firstname);
        if (lastname != null)
        localVarFormParams.put("lastname", lastname);
        if (email != null)
        localVarFormParams.put("email", email);
        if (mobile != null)
        localVarFormParams.put("mobile", mobile);
        if (address != null)
        localVarFormParams.put("address", address);
        if (zipcode != null)
        localVarFormParams.put("zipcode", zipcode);
        if (city != null)
        localVarFormParams.put("city", city);
        if (state != null)
        localVarFormParams.put("state", state);
        if (country != null)
        localVarFormParams.put("country", country);
        if (language != null)
        localVarFormParams.put("language", language);
        if (sendtype != null)
        localVarFormParams.put("sendtype", sendtype);
        if (notes != null)
        localVarFormParams.put("notes", notes);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createCustomerAutomaticValidateBeforeCall(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling createCustomerAutomatic(Async)");
        }
        
        // verify the required parameter 'firstname' is set
        if (firstname == null) {
            throw new ApiException("Missing the required parameter 'firstname' when calling createCustomerAutomatic(Async)");
        }
        
        // verify the required parameter 'lastname' is set
        if (lastname == null) {
            throw new ApiException("Missing the required parameter 'lastname' when calling createCustomerAutomatic(Async)");
        }
        
        // verify the required parameter 'sendtype' is set
        if (sendtype == null) {
            throw new ApiException("Missing the required parameter 'sendtype' when calling createCustomerAutomatic(Async)");
        }
        
        
        com.squareup.okhttp.Call call = createCustomerAutomaticCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createCustomerAutomatic(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        ApiResponse<String> resp = createCustomerAutomaticWithHttpInfo(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);
        return resp.getData();
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createCustomerAutomaticWithHttpInfo(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        com.squareup.okhttp.Call call = createCustomerAutomaticValidateBeforeCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request) (asynchronously)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createCustomerAutomaticAsync(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createCustomerAutomaticValidateBeforeCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createCustomerAutomaticWithDelayReviewRequest
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param delayBeforeFirstReviewRequest Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createCustomerAutomaticWithDelayReviewRequestCall(String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/createCustomerAutomaticWithDelayReviewRequest";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (companyid != null)
        localVarFormParams.put("companyid", companyid);
        if (firstname != null)
        localVarFormParams.put("firstname", firstname);
        if (lastname != null)
        localVarFormParams.put("lastname", lastname);
        if (email != null)
        localVarFormParams.put("email", email);
        if (mobile != null)
        localVarFormParams.put("mobile", mobile);
        if (address != null)
        localVarFormParams.put("address", address);
        if (zipcode != null)
        localVarFormParams.put("zipcode", zipcode);
        if (city != null)
        localVarFormParams.put("city", city);
        if (state != null)
        localVarFormParams.put("state", state);
        if (country != null)
        localVarFormParams.put("country", country);
        if (language != null)
        localVarFormParams.put("language", language);
        if (sendtype != null)
        localVarFormParams.put("sendtype", sendtype);
        if (notes != null)
        localVarFormParams.put("notes", notes);
        if (delayBeforeFirstReviewRequest != null)
        localVarFormParams.put("delayBeforeFirstReviewRequest", delayBeforeFirstReviewRequest);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createCustomerAutomaticWithDelayReviewRequestValidateBeforeCall(String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling createCustomerAutomaticWithDelayReviewRequest(Async)");
        }
        
        // verify the required parameter 'firstname' is set
        if (firstname == null) {
            throw new ApiException("Missing the required parameter 'firstname' when calling createCustomerAutomaticWithDelayReviewRequest(Async)");
        }
        
        // verify the required parameter 'lastname' is set
        if (lastname == null) {
            throw new ApiException("Missing the required parameter 'lastname' when calling createCustomerAutomaticWithDelayReviewRequest(Async)");
        }
        
        // verify the required parameter 'sendtype' is set
        if (sendtype == null) {
            throw new ApiException("Missing the required parameter 'sendtype' when calling createCustomerAutomaticWithDelayReviewRequest(Async)");
        }
        
        // verify the required parameter 'delayBeforeFirstReviewRequest' is set
        if (delayBeforeFirstReviewRequest == null) {
            throw new ApiException("Missing the required parameter 'delayBeforeFirstReviewRequest' when calling createCustomerAutomaticWithDelayReviewRequest(Async)");
        }
        
        
        com.squareup.okhttp.Call call = createCustomerAutomaticWithDelayReviewRequestCall(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param delayBeforeFirstReviewRequest Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void createCustomerAutomaticWithDelayReviewRequest(String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        createCustomerAutomaticWithDelayReviewRequestWithHttpInfo(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes);
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param delayBeforeFirstReviewRequest Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> createCustomerAutomaticWithDelayReviewRequestWithHttpInfo(String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        com.squareup.okhttp.Call call = createCustomerAutomaticWithDelayReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes, null, null);
        return apiClient.execute(call);
    }

    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request) (asynchronously)
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param delayBeforeFirstReviewRequest Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createCustomerAutomaticWithDelayReviewRequestAsync(String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createCustomerAutomaticWithDelayReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for createCustomerImmediateFirstReviewRequest
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createCustomerImmediateFirstReviewRequestCall(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/createCustomerImmediateFirstReviewRequest";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (companyid != null)
        localVarFormParams.put("companyid", companyid);
        if (firstname != null)
        localVarFormParams.put("firstname", firstname);
        if (lastname != null)
        localVarFormParams.put("lastname", lastname);
        if (email != null)
        localVarFormParams.put("email", email);
        if (mobile != null)
        localVarFormParams.put("mobile", mobile);
        if (address != null)
        localVarFormParams.put("address", address);
        if (zipcode != null)
        localVarFormParams.put("zipcode", zipcode);
        if (city != null)
        localVarFormParams.put("city", city);
        if (state != null)
        localVarFormParams.put("state", state);
        if (country != null)
        localVarFormParams.put("country", country);
        if (language != null)
        localVarFormParams.put("language", language);
        if (sendtype != null)
        localVarFormParams.put("sendtype", sendtype);
        if (notes != null)
        localVarFormParams.put("notes", notes);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createCustomerImmediateFirstReviewRequestValidateBeforeCall(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling createCustomerImmediateFirstReviewRequest(Async)");
        }
        
        // verify the required parameter 'firstname' is set
        if (firstname == null) {
            throw new ApiException("Missing the required parameter 'firstname' when calling createCustomerImmediateFirstReviewRequest(Async)");
        }
        
        // verify the required parameter 'lastname' is set
        if (lastname == null) {
            throw new ApiException("Missing the required parameter 'lastname' when calling createCustomerImmediateFirstReviewRequest(Async)");
        }
        
        // verify the required parameter 'sendtype' is set
        if (sendtype == null) {
            throw new ApiException("Missing the required parameter 'sendtype' when calling createCustomerImmediateFirstReviewRequest(Async)");
        }
        
        
        com.squareup.okhttp.Call call = createCustomerImmediateFirstReviewRequestCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a Customer AND Feedback / Review Requests
     * This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void createCustomerImmediateFirstReviewRequest(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        createCustomerImmediateFirstReviewRequestWithHttpInfo(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);
    }

    /**
     * Create a Customer AND Feedback / Review Requests
     * This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> createCustomerImmediateFirstReviewRequestWithHttpInfo(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        com.squareup.okhttp.Call call = createCustomerImmediateFirstReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, null, null);
        return apiClient.execute(call);
    }

    /**
     * Create a Customer AND Feedback / Review Requests (asynchronously)
     * This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createCustomerImmediateFirstReviewRequestAsync(String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createCustomerImmediateFirstReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for createCustomerManualScheduleOneReviewRequest
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createCustomerManualScheduleOneReviewRequestCall(String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/createCustomerManualScheduleOneReviewRequest";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (companyid != null)
        localVarFormParams.put("companyid", companyid);
        if (firstname != null)
        localVarFormParams.put("firstname", firstname);
        if (lastname != null)
        localVarFormParams.put("lastname", lastname);
        if (email != null)
        localVarFormParams.put("email", email);
        if (mobile != null)
        localVarFormParams.put("mobile", mobile);
        if (address != null)
        localVarFormParams.put("address", address);
        if (zipcode != null)
        localVarFormParams.put("zipcode", zipcode);
        if (city != null)
        localVarFormParams.put("city", city);
        if (state != null)
        localVarFormParams.put("state", state);
        if (country != null)
        localVarFormParams.put("country", country);
        if (language != null)
        localVarFormParams.put("language", language);
        if (sendtype != null)
        localVarFormParams.put("sendtype", sendtype);
        if (notes != null)
        localVarFormParams.put("notes", notes);
        if (emailnumber != null)
        localVarFormParams.put("emailnumber", emailnumber);
        if (smsnumber != null)
        localVarFormParams.put("smsnumber", smsnumber);
        if (scheduledate != null)
        localVarFormParams.put("scheduledate", scheduledate);
        if (scheduletime != null)
        localVarFormParams.put("scheduletime", scheduletime);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createCustomerManualScheduleOneReviewRequestValidateBeforeCall(String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'firstname' is set
        if (firstname == null) {
            throw new ApiException("Missing the required parameter 'firstname' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'lastname' is set
        if (lastname == null) {
            throw new ApiException("Missing the required parameter 'lastname' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'sendtype' is set
        if (sendtype == null) {
            throw new ApiException("Missing the required parameter 'sendtype' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'emailnumber' is set
        if (emailnumber == null) {
            throw new ApiException("Missing the required parameter 'emailnumber' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'smsnumber' is set
        if (smsnumber == null) {
            throw new ApiException("Missing the required parameter 'smsnumber' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'scheduledate' is set
        if (scheduledate == null) {
            throw new ApiException("Missing the required parameter 'scheduledate' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'scheduletime' is set
        if (scheduletime == null) {
            throw new ApiException("Missing the required parameter 'scheduletime' when calling createCustomerManualScheduleOneReviewRequest(Async)");
        }
        
        
        com.squareup.okhttp.Call call = createCustomerManualScheduleOneReviewRequestCall(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     * This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void createCustomerManualScheduleOneReviewRequest(String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        createCustomerManualScheduleOneReviewRequestWithHttpInfo(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes);
    }

    /**
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     * This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> createCustomerManualScheduleOneReviewRequestWithHttpInfo(String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes) throws ApiException {
        com.squareup.okhttp.Call call = createCustomerManualScheduleOneReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes, null, null);
        return apiClient.execute(call);
    }

    /**
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling) (asynchronously)
     * This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time 
     * @param companyid Company ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
     * @param notes Additional Customer Notes (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createCustomerManualScheduleOneReviewRequestAsync(String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createCustomerManualScheduleOneReviewRequestValidateBeforeCall(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for deleteCustomer
     * @param customerid Customer ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteCustomerCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/deleteCustomer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (customerid != null)
        localVarFormParams.put("customerid", customerid);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteCustomerValidateBeforeCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling deleteCustomer(Async)");
        }
        
        
        com.squareup.okhttp.Call call = deleteCustomerCall(customerid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Delete ONE Customer record
     * This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue
     * @param customerid Customer ID (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteCustomer(String customerid) throws ApiException {
        deleteCustomerWithHttpInfo(customerid);
    }

    /**
     * Delete ONE Customer record
     * This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue
     * @param customerid Customer ID (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteCustomerWithHttpInfo(String customerid) throws ApiException {
        com.squareup.okhttp.Call call = deleteCustomerValidateBeforeCall(customerid, null, null);
        return apiClient.execute(call);
    }

    /**
     * Delete ONE Customer record (asynchronously)
     * This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue
     * @param customerid Customer ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteCustomerAsync(String customerid, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteCustomerValidateBeforeCall(customerid, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getAllCustomersBycompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getAllCustomersBycompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getAllCustomersBycompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getAllCustomersBycompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getAllCustomersBycompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getAllCustomersBycompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     * This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page
     * @param companyid Company ID (required)
     * @return List&lt;Customer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Customer> getAllCustomersBycompanyId(String companyid) throws ApiException {
        ApiResponse<List<Customer>> resp = getAllCustomersBycompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     * This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;Customer&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Customer>> getAllCustomersBycompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getAllCustomersBycompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<Customer>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Information on ALL Customers of a Company / Location / Feedback Page (asynchronously)
     * This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getAllCustomersBycompanyIdAsync(String companyid, final ApiCallback<List<Customer>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getAllCustomersBycompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Customer>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getCustomersWhoHaveNotYetSubmittedReview
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCustomersWhoHaveNotYetSubmittedReviewCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getCustomersWhoHaveNotYetSubmittedReview";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCustomersWhoHaveNotYetSubmittedReviewValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getCustomersWhoHaveNotYetSubmittedReview(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getCustomersWhoHaveNotYetSubmittedReviewCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get a list of Customers who have not yet submitted their Review / Feedback
     * This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests
     * @param companyid Company ID (required)
     * @return List&lt;CustomerWhoHaveNotResponded&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<CustomerWhoHaveNotResponded> getCustomersWhoHaveNotYetSubmittedReview(String companyid) throws ApiException {
        ApiResponse<List<CustomerWhoHaveNotResponded>> resp = getCustomersWhoHaveNotYetSubmittedReviewWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get a list of Customers who have not yet submitted their Review / Feedback
     * This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;CustomerWhoHaveNotResponded&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<CustomerWhoHaveNotResponded>> getCustomersWhoHaveNotYetSubmittedReviewWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getCustomersWhoHaveNotYetSubmittedReviewValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<CustomerWhoHaveNotResponded>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a list of Customers who have not yet submitted their Review / Feedback (asynchronously)
     * This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCustomersWhoHaveNotYetSubmittedReviewAsync(String companyid, final ApiCallback<List<CustomerWhoHaveNotResponded>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCustomersWhoHaveNotYetSubmittedReviewValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<CustomerWhoHaveNotResponded>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSingleCustomer
     * @param customerid Customer ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSingleCustomerCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getSingleCustomer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (customerid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "customerid", customerid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSingleCustomerValidateBeforeCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling getSingleCustomer(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getSingleCustomerCall(customerid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Information of ONE Customer
     * This API call returns information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @return List&lt;Customer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Customer> getSingleCustomer(String customerid) throws ApiException {
        ApiResponse<List<Customer>> resp = getSingleCustomerWithHttpInfo(customerid);
        return resp.getData();
    }

    /**
     * Get Information of ONE Customer
     * This API call returns information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @return ApiResponse&lt;List&lt;Customer&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Customer>> getSingleCustomerWithHttpInfo(String customerid) throws ApiException {
        com.squareup.okhttp.Call call = getSingleCustomerValidateBeforeCall(customerid, null, null);
        Type localVarReturnType = new TypeToken<List<Customer>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Information of ONE Customer (asynchronously)
     * This API call returns information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSingleCustomerAsync(String customerid, final ApiCallback<List<Customer>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSingleCustomerValidateBeforeCall(customerid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Customer>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateCustomer
     * @param customerid Customer ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param notes Additional Customer Notes (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country (optional)
     * @param language Customer Language (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateCustomerCall(String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/updateCustomer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (customerid != null)
        localVarFormParams.put("customerid", customerid);
        if (firstname != null)
        localVarFormParams.put("firstname", firstname);
        if (lastname != null)
        localVarFormParams.put("lastname", lastname);
        if (email != null)
        localVarFormParams.put("email", email);
        if (mobile != null)
        localVarFormParams.put("mobile", mobile);
        if (address != null)
        localVarFormParams.put("address", address);
        if (zipcode != null)
        localVarFormParams.put("zipcode", zipcode);
        if (city != null)
        localVarFormParams.put("city", city);
        if (state != null)
        localVarFormParams.put("state", state);
        if (country != null)
        localVarFormParams.put("country", country);
        if (language != null)
        localVarFormParams.put("language", language);
        if (notes != null)
        localVarFormParams.put("notes", notes);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateCustomerValidateBeforeCall(String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling updateCustomer(Async)");
        }
        
        // verify the required parameter 'firstname' is set
        if (firstname == null) {
            throw new ApiException("Missing the required parameter 'firstname' when calling updateCustomer(Async)");
        }
        
        // verify the required parameter 'lastname' is set
        if (lastname == null) {
            throw new ApiException("Missing the required parameter 'lastname' when calling updateCustomer(Async)");
        }
        
        // verify the required parameter 'notes' is set
        if (notes == null) {
            throw new ApiException("Missing the required parameter 'notes' when calling updateCustomer(Async)");
        }
        
        
        com.squareup.okhttp.Call call = updateCustomerCall(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Update the record of ONE Customer
     * This API call updates information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param notes Additional Customer Notes (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country (optional)
     * @param language Customer Language (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void updateCustomer(String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language) throws ApiException {
        updateCustomerWithHttpInfo(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language);
    }

    /**
     * Update the record of ONE Customer
     * This API call updates information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param notes Additional Customer Notes (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country (optional)
     * @param language Customer Language (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> updateCustomerWithHttpInfo(String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language) throws ApiException {
        com.squareup.okhttp.Call call = updateCustomerValidateBeforeCall(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language, null, null);
        return apiClient.execute(call);
    }

    /**
     * Update the record of ONE Customer (asynchronously)
     * This API call updates information from Reputation Builder on ONE existing Customer
     * @param customerid Customer ID (required)
     * @param firstname Customer First Name (required)
     * @param lastname Customer Last Name (required)
     * @param notes Additional Customer Notes (required)
     * @param email Customer Email (optional)
     * @param mobile Customer Mobile Phone (optional)
     * @param address Customer Postal Address (optional)
     * @param zipcode Customer Zipcode (optional)
     * @param city Customer City (optional)
     * @param state Customer State / Province / Region (optional)
     * @param country Customer Country (optional)
     * @param language Customer Language (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateCustomerAsync(String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateCustomerValidateBeforeCall(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
