/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RescheduleApi {
    private ApiClient apiClient;

    public RescheduleApi() {
        this(Configuration.getDefaultApiClient());
    }

    public RescheduleApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for rescheduleCustomerAutomatic
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call rescheduleCustomerAutomaticCall(String customerid, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/rescheduleCustomerAutomatic";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (customerid != null)
        localVarFormParams.put("customerid", customerid);
        if (language != null)
        localVarFormParams.put("language", language);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call rescheduleCustomerAutomaticValidateBeforeCall(String customerid, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling rescheduleCustomerAutomatic(Async)");
        }
        
        // verify the required parameter 'language' is set
        if (language == null) {
            throw new ApiException("Missing the required parameter 'language' when calling rescheduleCustomerAutomatic(Async)");
        }
        
        
        com.squareup.okhttp.Call call = rescheduleCustomerAutomaticCall(customerid, language, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Reschedule Customer (Automatic)
     * Reschedule Customer (Automatic) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void rescheduleCustomerAutomatic(String customerid, String language) throws ApiException {
        rescheduleCustomerAutomaticWithHttpInfo(customerid, language);
    }

    /**
     * Reschedule Customer (Automatic)
     * Reschedule Customer (Automatic) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> rescheduleCustomerAutomaticWithHttpInfo(String customerid, String language) throws ApiException {
        com.squareup.okhttp.Call call = rescheduleCustomerAutomaticValidateBeforeCall(customerid, language, null, null);
        return apiClient.execute(call);
    }

    /**
     * Reschedule Customer (Automatic) (asynchronously)
     * Reschedule Customer (Automatic) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call rescheduleCustomerAutomaticAsync(String customerid, String language, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = rescheduleCustomerAutomaticValidateBeforeCall(customerid, language, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for rescheduleCustomerImmediate
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call rescheduleCustomerImmediateCall(String customerid, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/rescheduleCustomerImmediate";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (customerid != null)
        localVarFormParams.put("customerid", customerid);
        if (language != null)
        localVarFormParams.put("language", language);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call rescheduleCustomerImmediateValidateBeforeCall(String customerid, String language, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling rescheduleCustomerImmediate(Async)");
        }
        
        // verify the required parameter 'language' is set
        if (language == null) {
            throw new ApiException("Missing the required parameter 'language' when calling rescheduleCustomerImmediate(Async)");
        }
        
        
        com.squareup.okhttp.Call call = rescheduleCustomerImmediateCall(customerid, language, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Reschedule Customer (Send right away)
     * Reschedule Customer (Send right away) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void rescheduleCustomerImmediate(String customerid, String language) throws ApiException {
        rescheduleCustomerImmediateWithHttpInfo(customerid, language);
    }

    /**
     * Reschedule Customer (Send right away)
     * Reschedule Customer (Send right away) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> rescheduleCustomerImmediateWithHttpInfo(String customerid, String language) throws ApiException {
        com.squareup.okhttp.Call call = rescheduleCustomerImmediateValidateBeforeCall(customerid, language, null, null);
        return apiClient.execute(call);
    }

    /**
     * Reschedule Customer (Send right away) (asynchronously)
     * Reschedule Customer (Send right away) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call rescheduleCustomerImmediateAsync(String customerid, String language, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = rescheduleCustomerImmediateValidateBeforeCall(customerid, language, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for rescheduleManualOneReviewRequest
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call rescheduleManualOneReviewRequestCall(String customerid, String language, String scheduledate, String scheduletime, String emailnumber, String smsnumber, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/rescheduleManualOneReviewRequest";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (customerid != null)
        localVarFormParams.put("customerid", customerid);
        if (language != null)
        localVarFormParams.put("language", language);
        if (scheduledate != null)
        localVarFormParams.put("scheduledate", scheduledate);
        if (scheduletime != null)
        localVarFormParams.put("scheduletime", scheduletime);
        if (emailnumber != null)
        localVarFormParams.put("emailnumber", emailnumber);
        if (smsnumber != null)
        localVarFormParams.put("smsnumber", smsnumber);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call rescheduleManualOneReviewRequestValidateBeforeCall(String customerid, String language, String scheduledate, String scheduletime, String emailnumber, String smsnumber, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'language' is set
        if (language == null) {
            throw new ApiException("Missing the required parameter 'language' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'scheduledate' is set
        if (scheduledate == null) {
            throw new ApiException("Missing the required parameter 'scheduledate' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'scheduletime' is set
        if (scheduletime == null) {
            throw new ApiException("Missing the required parameter 'scheduletime' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'emailnumber' is set
        if (emailnumber == null) {
            throw new ApiException("Missing the required parameter 'emailnumber' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        // verify the required parameter 'smsnumber' is set
        if (smsnumber == null) {
            throw new ApiException("Missing the required parameter 'smsnumber' when calling rescheduleManualOneReviewRequest(Async)");
        }
        
        
        com.squareup.okhttp.Call call = rescheduleManualOneReviewRequestCall(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Reschedule Customer (Manual Schedule)
     * Reschedule Customer (Manual Schedule) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void rescheduleManualOneReviewRequest(String customerid, String language, String scheduledate, String scheduletime, String emailnumber, String smsnumber) throws ApiException {
        rescheduleManualOneReviewRequestWithHttpInfo(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber);
    }

    /**
     * Reschedule Customer (Manual Schedule)
     * Reschedule Customer (Manual Schedule) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> rescheduleManualOneReviewRequestWithHttpInfo(String customerid, String language, String scheduledate, String scheduletime, String emailnumber, String smsnumber) throws ApiException {
        com.squareup.okhttp.Call call = rescheduleManualOneReviewRequestValidateBeforeCall(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber, null, null);
        return apiClient.execute(call);
    }

    /**
     * Reschedule Customer (Manual Schedule) (asynchronously)
     * Reschedule Customer (Manual Schedule) 
     * @param customerid Customer ID (required)
     * @param language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
     * @param scheduledate Schedule date (yyyy/mm/dd)  (required)
     * @param scheduletime Schedule time (HH:MM 24 hours format)  (required)
     * @param emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call rescheduleManualOneReviewRequestAsync(String customerid, String language, String scheduledate, String scheduletime, String emailnumber, String smsnumber, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = rescheduleManualOneReviewRequestValidateBeforeCall(customerid, language, scheduledate, scheduletime, emailnumber, smsnumber, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
