/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Error;
import io.swagger.client.model.OverallCompanyRating;
import io.swagger.client.model.OverallRatingAndReviewCount;
import io.swagger.client.model.ReviewSitesRating;
import io.swagger.client.model.ReviewSitesReputationChange;
import io.swagger.client.model.ReviewSitesReviewCount;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ReviewsStatsApi {
    private ApiClient apiClient;

    public ReviewsStatsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ReviewsStatsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getNumberOfReviewsPostedInLastDaysByCompanyId
     * @param companyid Company ID (required)
     * @param lastHowManyDays Last how many days (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getNumberOfReviewsPostedInLastDaysByCompanyIdCall(String companyid, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getNumberOfReviewsPostedInLastDaysByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "lastHowManyDays", lastHowManyDays));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getNumberOfReviewsPostedInLastDaysByCompanyIdValidateBeforeCall(String companyid, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getNumberOfReviewsPostedInLastDaysByCompanyId(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getNumberOfReviewsPostedInLastDaysByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getNumberOfReviewsPostedInLastDaysByCompanyIdCall(companyid, lastHowManyDays, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get total reviews received for each review site
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @param lastHowManyDays Last how many days (required)
     * @return List&lt;ReviewSitesReviewCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReviewSitesReviewCount> getNumberOfReviewsPostedInLastDaysByCompanyId(String companyid, String lastHowManyDays) throws ApiException {
        ApiResponse<List<ReviewSitesReviewCount>> resp = getNumberOfReviewsPostedInLastDaysByCompanyIdWithHttpInfo(companyid, lastHowManyDays);
        return resp.getData();
    }

    /**
     * Get total reviews received for each review site
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @param lastHowManyDays Last how many days (required)
     * @return ApiResponse&lt;List&lt;ReviewSitesReviewCount&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReviewSitesReviewCount>> getNumberOfReviewsPostedInLastDaysByCompanyIdWithHttpInfo(String companyid, String lastHowManyDays) throws ApiException {
        com.squareup.okhttp.Call call = getNumberOfReviewsPostedInLastDaysByCompanyIdValidateBeforeCall(companyid, lastHowManyDays, null, null);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get total reviews received for each review site (asynchronously)
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @param lastHowManyDays Last how many days (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getNumberOfReviewsPostedInLastDaysByCompanyIdAsync(String companyid, String lastHowManyDays, final ApiCallback<List<ReviewSitesReviewCount>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getNumberOfReviewsPostedInLastDaysByCompanyIdValidateBeforeCall(companyid, lastHowManyDays, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getNumberOfReviewsRequiredToAchieve5StarByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getNumberOfReviewsRequiredToAchieve5StarByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getNumberOfReviewsRequiredToAchieve5StarByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getNumberOfReviewsRequiredToAchieve5StarByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getNumberOfReviewsRequiredToAchieve5StarByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getNumberOfReviewsRequiredToAchieve5StarByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 
     * @param companyid Company ID (required)
     * @return List&lt;ReviewSitesReviewCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReviewSitesReviewCount> getNumberOfReviewsRequiredToAchieve5StarByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<ReviewSitesReviewCount>> resp = getNumberOfReviewsRequiredToAchieve5StarByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;ReviewSitesReviewCount&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReviewSitesReviewCount>> getNumberOfReviewsRequiredToAchieve5StarByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getNumberOfReviewsRequiredToAchieve5StarByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience  (asynchronously)
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getNumberOfReviewsRequiredToAchieve5StarByCompanyIdAsync(String companyid, final ApiCallback<List<ReviewSitesReviewCount>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getNumberOfReviewsRequiredToAchieve5StarByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getOverallRatingAndReviewCountForPlatformReviewsByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getOverallRatingAndReviewCountForPlatformReviewsByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getOverallRatingAndReviewCountForPlatformReviewsByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.
     * @param companyid Company ID (required)
     * @return List&lt;OverallRatingAndReviewCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<OverallRatingAndReviewCount> getOverallRatingAndReviewCountForPlatformReviewsByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<OverallRatingAndReviewCount>> resp = getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;OverallRatingAndReviewCount&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<OverallRatingAndReviewCount>> getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<OverallRatingAndReviewCount>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews   (asynchronously)
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdAsync(String companyid, final ApiCallback<List<OverallRatingAndReviewCount>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<OverallRatingAndReviewCount>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getOverallRatingForEachReviewSiteByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingForEachReviewSiteByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getOverallRatingForEachReviewSiteByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getOverallRatingForEachReviewSiteByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getOverallRatingForEachReviewSiteByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getOverallRatingForEachReviewSiteByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get overall rating for each review site
     * Get overall rating for each review site
     * @param companyid Company ID (required)
     * @return List&lt;ReviewSitesRating&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReviewSitesRating> getOverallRatingForEachReviewSiteByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<ReviewSitesRating>> resp = getOverallRatingForEachReviewSiteByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get overall rating for each review site
     * Get overall rating for each review site
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;ReviewSitesRating&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReviewSitesRating>> getOverallRatingForEachReviewSiteByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getOverallRatingForEachReviewSiteByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<ReviewSitesRating>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get overall rating for each review site (asynchronously)
     * Get overall rating for each review site
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingForEachReviewSiteByCompanyIdAsync(String companyid, final ApiCallback<List<ReviewSitesRating>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getOverallRatingForEachReviewSiteByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReviewSitesRating>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getOverallRatingOfCompanyByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingOfCompanyByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getOverallRatingOfCompanyByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getOverallRatingOfCompanyByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getOverallRatingOfCompanyByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getOverallRatingOfCompanyByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get The Overall Rating of a Company / Location / Feedback Page 
     * This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 
     * @param companyid Company ID (required)
     * @return List&lt;OverallCompanyRating&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<OverallCompanyRating> getOverallRatingOfCompanyByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<OverallCompanyRating>> resp = getOverallRatingOfCompanyByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get The Overall Rating of a Company / Location / Feedback Page 
     * This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;OverallCompanyRating&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<OverallCompanyRating>> getOverallRatingOfCompanyByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getOverallRatingOfCompanyByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<OverallCompanyRating>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get The Overall Rating of a Company / Location / Feedback Page  (asynchronously)
     * This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getOverallRatingOfCompanyByCompanyIdAsync(String companyid, final ApiCallback<List<OverallCompanyRating>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getOverallRatingOfCompanyByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<OverallCompanyRating>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getOverallReputationChangeOfAllReviewSitesByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getOverallReputationChangeOfAllReviewSitesByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getOverallReputationChangeOfAllReviewSitesByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getOverallReputationChangeOfAllReviewSitesByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getOverallReputationChangeOfAllReviewSitesByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getOverallReputationChangeOfAllReviewSitesByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get the Overall Reputation Increase / Decrease of ALL Review Sites 
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 
     * @param companyid Company ID (required)
     * @return List&lt;ReviewSitesReputationChange&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReviewSitesReputationChange> getOverallReputationChangeOfAllReviewSitesByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<ReviewSitesReputationChange>> resp = getOverallReputationChangeOfAllReviewSitesByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get the Overall Reputation Increase / Decrease of ALL Review Sites 
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;ReviewSitesReputationChange&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReviewSitesReputationChange>> getOverallReputationChangeOfAllReviewSitesByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getOverallReputationChangeOfAllReviewSitesByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReputationChange>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the Overall Reputation Increase / Decrease of ALL Review Sites  (asynchronously)
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getOverallReputationChangeOfAllReviewSitesByCompanyIdAsync(String companyid, final ApiCallback<List<ReviewSitesReputationChange>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getOverallReputationChangeOfAllReviewSitesByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReputationChange>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getTotalReviewsReceivedForEachReviewSiteByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getTotalReviewsReceivedForEachReviewSiteByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getTotalReviewsReceivedForEachReviewSiteByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getTotalReviewsReceivedForEachReviewSiteByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getTotalReviewsReceivedForEachReviewSiteByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getTotalReviewsReceivedForEachReviewSiteByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get total reviews received for each review site
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @return List&lt;ReviewSitesReviewCount&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReviewSitesReviewCount> getTotalReviewsReceivedForEachReviewSiteByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<ReviewSitesReviewCount>> resp = getTotalReviewsReceivedForEachReviewSiteByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get total reviews received for each review site
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;ReviewSitesReviewCount&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReviewSitesReviewCount>> getTotalReviewsReceivedForEachReviewSiteByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getTotalReviewsReceivedForEachReviewSiteByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get total reviews received for each review site (asynchronously)
     * Get total reviews received for each review site
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTotalReviewsReceivedForEachReviewSiteByCompanyIdAsync(String companyid, final ApiCallback<List<ReviewSitesReviewCount>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTotalReviewsReceivedForEachReviewSiteByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReviewSitesReviewCount>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
