/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Error;
import io.swagger.client.model.SentLog;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SentLogApi {
    private ApiClient apiClient;

    public SentLogApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SentLogApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getSentLogByCompanyId
     * @param companyid Company ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSentLogByCompanyIdCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getSentLogByCompanyId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "companyid", companyid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSentLogByCompanyIdValidateBeforeCall(String companyid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getSentLogByCompanyId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getSentLogByCompanyIdCall(companyid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get company&#39;s sent log
     * Get company&#39;s sent log
     * @param companyid Company ID (required)
     * @return List&lt;SentLog&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SentLog> getSentLogByCompanyId(String companyid) throws ApiException {
        ApiResponse<List<SentLog>> resp = getSentLogByCompanyIdWithHttpInfo(companyid);
        return resp.getData();
    }

    /**
     * Get company&#39;s sent log
     * Get company&#39;s sent log
     * @param companyid Company ID (required)
     * @return ApiResponse&lt;List&lt;SentLog&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SentLog>> getSentLogByCompanyIdWithHttpInfo(String companyid) throws ApiException {
        com.squareup.okhttp.Call call = getSentLogByCompanyIdValidateBeforeCall(companyid, null, null);
        Type localVarReturnType = new TypeToken<List<SentLog>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get company&#39;s sent log (asynchronously)
     * Get company&#39;s sent log
     * @param companyid Company ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSentLogByCompanyIdAsync(String companyid, final ApiCallback<List<SentLog>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSentLogByCompanyIdValidateBeforeCall(companyid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SentLog>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getSentLogByCustomerId
     * @param customerid Customer ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getSentLogByCustomerIdCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/getSentLogByCustomerId";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (customerid != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "customerid", customerid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getSentLogByCustomerIdValidateBeforeCall(String customerid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'customerid' is set
        if (customerid == null) {
            throw new ApiException("Missing the required parameter 'customerid' when calling getSentLogByCustomerId(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getSentLogByCustomerIdCall(customerid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get a customerâ€™s sent log
     * Get a customerâ€™s sent log
     * @param customerid Customer ID (required)
     * @return List&lt;SentLog&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SentLog> getSentLogByCustomerId(String customerid) throws ApiException {
        ApiResponse<List<SentLog>> resp = getSentLogByCustomerIdWithHttpInfo(customerid);
        return resp.getData();
    }

    /**
     * Get a customerâ€™s sent log
     * Get a customerâ€™s sent log
     * @param customerid Customer ID (required)
     * @return ApiResponse&lt;List&lt;SentLog&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SentLog>> getSentLogByCustomerIdWithHttpInfo(String customerid) throws ApiException {
        com.squareup.okhttp.Call call = getSentLogByCustomerIdValidateBeforeCall(customerid, null, null);
        Type localVarReturnType = new TypeToken<List<SentLog>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get a customerâ€™s sent log (asynchronously)
     * Get a customerâ€™s sent log
     * @param customerid Customer ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSentLogByCustomerIdAsync(String customerid, final ApiCallback<List<SentLog>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSentLogByCustomerIdValidateBeforeCall(customerid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SentLog>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
