/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Customer;
import io.swagger.client.model.CustomerWhoHaveNotResponded;
import io.swagger.client.model.Error;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for CustomerApi
 */
@Ignore
public class CustomerApiTest {

    private final CustomerApi api = new CustomerApi();

    
    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
     *
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH NO DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCustomerAutomaticTest() throws ApiException {
        String companyid = null;
        String firstname = null;
        String lastname = null;
        String sendtype = null;
        String email = null;
        String mobile = null;
        String address = null;
        String zipcode = null;
        String city = null;
        String state = null;
        String country = null;
        String language = null;
        String notes = null;
        String response = api.createCustomerAutomatic(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);

        // TODO: test validations
    }
    
    /**
     * Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
     *
     * This API call creates a Customer in Reputation Builder, AND schedules an Automatic Email AND / OR SMS Feedback / Review Request Sequence, WITH A DELAY BEFORE SENDING THE FIRST FEEDBACK / REVIEW REQUEST, based on settings of the Company / Location -&gt; Notifications -&gt; Email AND SMS Tabs 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCustomerAutomaticWithDelayReviewRequestTest() throws ApiException {
        String companyid = null;
        String firstname = null;
        String lastname = null;
        String sendtype = null;
        String delayBeforeFirstReviewRequest = null;
        String email = null;
        String mobile = null;
        String address = null;
        String zipcode = null;
        String city = null;
        String state = null;
        String country = null;
        String language = null;
        String notes = null;
        api.createCustomerAutomaticWithDelayReviewRequest(companyid, firstname, lastname, sendtype, delayBeforeFirstReviewRequest, email, mobile, address, zipcode, city, state, country, language, notes);

        // TODO: test validations
    }
    
    /**
     * Create a Customer AND Feedback / Review Requests
     *
     * This API call creates a Customer in Reputation Builder AND Feedback / Review Request #1 (Email #1 AND/OR SMS #1 ONLY). Feedback / Review Request(s) are then sent immediately 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCustomerImmediateFirstReviewRequestTest() throws ApiException {
        String companyid = null;
        String firstname = null;
        String lastname = null;
        String sendtype = null;
        String email = null;
        String mobile = null;
        String address = null;
        String zipcode = null;
        String city = null;
        String state = null;
        String country = null;
        String language = null;
        String notes = null;
        api.createCustomerImmediateFirstReviewRequest(companyid, firstname, lastname, sendtype, email, mobile, address, zipcode, city, state, country, language, notes);

        // TODO: test validations
    }
    
    /**
     * Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
     *
     * This API call creates a Customer in Reputation Builder AND one Feedback / Review Request. You decide which Feedback / Review Request # to send, the sending method (Email or SMS) and you have full control of the sending date and time 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createCustomerManualScheduleOneReviewRequestTest() throws ApiException {
        String companyid = null;
        String firstname = null;
        String lastname = null;
        String sendtype = null;
        String emailnumber = null;
        String smsnumber = null;
        String scheduledate = null;
        String scheduletime = null;
        String email = null;
        String mobile = null;
        String address = null;
        String zipcode = null;
        String city = null;
        String state = null;
        String country = null;
        String language = null;
        String notes = null;
        api.createCustomerManualScheduleOneReviewRequest(companyid, firstname, lastname, sendtype, emailnumber, smsnumber, scheduledate, scheduletime, email, mobile, address, zipcode, city, state, country, language, notes);

        // TODO: test validations
    }
    
    /**
     * Delete ONE Customer record
     *
     * This API call deletes an existing Customer from Reputation Builder. It will also delete all Email / SMS Requests still in the Queue
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteCustomerTest() throws ApiException {
        String customerid = null;
        api.deleteCustomer(customerid);

        // TODO: test validations
    }
    
    /**
     * Get Information on ALL Customers of a Company / Location / Feedback Page
     *
     * This API call returns information from Reputation Builder on ALL existing Customers of a Company / Location / Feedback Page
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getAllCustomersBycompanyIdTest() throws ApiException {
        String companyid = null;
        List<Customer> response = api.getAllCustomersBycompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get a list of Customers who have not yet submitted their Review / Feedback
     *
     * This API call returns the list of Customers of a Company / Location / Feedback Page who have not yet responded to Feedback / Review Requests
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getCustomersWhoHaveNotYetSubmittedReviewTest() throws ApiException {
        String companyid = null;
        List<CustomerWhoHaveNotResponded> response = api.getCustomersWhoHaveNotYetSubmittedReview(companyid);

        // TODO: test validations
    }
    
    /**
     * Get Information of ONE Customer
     *
     * This API call returns information from Reputation Builder on ONE existing Customer
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSingleCustomerTest() throws ApiException {
        String customerid = null;
        List<Customer> response = api.getSingleCustomer(customerid);

        // TODO: test validations
    }
    
    /**
     * Update the record of ONE Customer
     *
     * This API call updates information from Reputation Builder on ONE existing Customer
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateCustomerTest() throws ApiException {
        String customerid = null;
        String firstname = null;
        String lastname = null;
        String notes = null;
        String email = null;
        String mobile = null;
        String address = null;
        String zipcode = null;
        String city = null;
        String state = null;
        String country = null;
        String language = null;
        api.updateCustomer(customerid, firstname, lastname, notes, email, mobile, address, zipcode, city, state, country, language);

        // TODO: test validations
    }
    
}
