/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Error;
import io.swagger.client.model.Review;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ReviewsApi
 */
@Ignore
public class ReviewsApiTest {

    private final ReviewsApi api = new ReviewsApi();

    
    /**
     * Get X last reviews less than X days old of a company
     *
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByCompanyIDTest() throws ApiException {
        String companyid = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        List<Review> response = api.getReviewsByCompanyID(companyid, howManyReviews, lastHowManyDays);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews less than X days old of a review site of a company
     *
     * Get X last reviews less than X days old of a review site (For example, Google reviewsâ€¦)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByCompanyIDAndReviewSiteTest() throws ApiException {
        String companyid = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        String reviewsSite = null;
        List<Review> response = api.getReviewsByCompanyIDAndReviewSite(companyid, howManyReviews, lastHowManyDays, reviewsSite);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews that equal or over X stars of a review site of a company
     *
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByCompanyIDRatingAndReviewSiteTest() throws ApiException {
        String companyid = null;
        String howManyReviews = null;
        String minimumRatings = null;
        String reviewsSite = null;
        List<Review> response = api.getReviewsByCompanyIDRatingAndReviewSite(companyid, howManyReviews, minimumRatings, reviewsSite);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews that equal or over X stars of a company
     *
     * Get X last reviews that between X stars (For example, last 50 reviews between 2 to 5 stars)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByCompanyIdAndRatingTest() throws ApiException {
        String companyid = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        String minimumRatings = null;
        String maximumRatings = null;
        List<Review> response = api.getReviewsByCompanyIdAndRating(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews less than X days old of an account
     *
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByUserNameTest() throws ApiException {
        String username = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        List<Review> response = api.getReviewsByUserName(username, howManyReviews, lastHowManyDays);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews that equal or over X stars of an account
     *
     * Get X last reviews that equal or over X stars (For example, last 50 reviews that are equal or over 4 stars)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByUserNameAndRatingTest() throws ApiException {
        String username = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        String minimumRatings = null;
        List<Review> response = api.getReviewsByUserNameAndRating(username, howManyReviews, lastHowManyDays, minimumRatings);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews less than X days old of a review site of an account
     *
     * Get X last reviews less than X days old of a review site (For Example, Google reviewsâ€¦)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByUserNameAndReviewSiteTest() throws ApiException {
        String username = null;
        String howManyReviews = null;
        String lastHowManyDays = null;
        String reviewsSite = null;
        List<Review> response = api.getReviewsByUserNameAndReviewSite(username, howManyReviews, lastHowManyDays, reviewsSite);

        // TODO: test validations
    }
    
    /**
     * Get X last reviews that equal or over X stars of a review site of an account
     *
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getReviewsByUserNameRatingAndReviewSiteTest() throws ApiException {
        String username = null;
        String howManyReviews = null;
        String minimumRatings = null;
        String reviewsSite = null;
        List<Review> response = api.getReviewsByUserNameRatingAndReviewSite(username, howManyReviews, minimumRatings, reviewsSite);

        // TODO: test validations
    }
    
    /**
     * Comment on a Feedback / Review
     *
     * This API call posts a Comment on a Feedback / Review. When posted, the Platform sends an Email to the Commenter / Reviewer with a copy of the posted Comment. NOTE: The Moderation Team receives a copy of the Email sent to the Commenter / Reviewer  The API call has the same effect as using the Reputation Control Center (URL: https://reputationcrm.com/reputation-control), locating in the datatable the Feedback / Review that will be commented, and clicking on the &#39;Comment on the Platform&#39; button to leave a Comment  Please refer https://reputationcrm.com/api/repcrm-api-img/CommentOnReview.jpg for more information 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void postCommentOnReviewTest() throws ApiException {
        String reviewid = null;
        String commenttext = null;
        api.postCommentOnReview(reviewid, commenttext);

        // TODO: test validations
    }
    
}
