/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Error;
import io.swagger.client.model.OverallCompanyRating;
import io.swagger.client.model.OverallRatingAndReviewCount;
import io.swagger.client.model.ReviewSitesRating;
import io.swagger.client.model.ReviewSitesReputationChange;
import io.swagger.client.model.ReviewSitesReviewCount;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ReviewsStatsApi
 */
@Ignore
public class ReviewsStatsApiTest {

    private final ReviewsStatsApi api = new ReviewsStatsApi();

    
    /**
     * Get total reviews received for each review site
     *
     * Get total reviews received for each review site
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getNumberOfReviewsPostedInLastDaysByCompanyIdTest() throws ApiException {
        String companyid = null;
        String lastHowManyDays = null;
        List<ReviewSitesReviewCount> response = api.getNumberOfReviewsPostedInLastDaysByCompanyId(companyid, lastHowManyDays);

        // TODO: test validations
    }
    
    /**
     * Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
     *
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getNumberOfReviewsRequiredToAchieve5StarByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<ReviewSitesReviewCount> response = api.getNumberOfReviewsRequiredToAchieve5StarByCompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
     *
     * Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getOverallRatingAndReviewCountForPlatformReviewsByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<OverallRatingAndReviewCount> response = api.getOverallRatingAndReviewCountForPlatformReviewsByCompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get overall rating for each review site
     *
     * Get overall rating for each review site
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getOverallRatingForEachReviewSiteByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<ReviewSitesRating> response = api.getOverallRatingForEachReviewSiteByCompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get The Overall Rating of a Company / Location / Feedback Page 
     *
     * This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getOverallRatingOfCompanyByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<OverallCompanyRating> response = api.getOverallRatingOfCompanyByCompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get the Overall Reputation Increase / Decrease of ALL Review Sites 
     *
     * This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getOverallReputationChangeOfAllReviewSitesByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<ReviewSitesReputationChange> response = api.getOverallReputationChangeOfAllReviewSitesByCompanyId(companyid);

        // TODO: test validations
    }
    
    /**
     * Get total reviews received for each review site
     *
     * Get total reviews received for each review site
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getTotalReviewsReceivedForEachReviewSiteByCompanyIdTest() throws ApiException {
        String companyid = null;
        List<ReviewSitesReviewCount> response = api.getTotalReviewsReceivedForEachReviewSiteByCompanyId(companyid);

        // TODO: test validations
    }
    
}
